from abc import ABC, abstractmethod

import pygame


class CharacterRenderer(ABC):

    @property
    @abstractmethod
    def tileDefaultWidth(self) -> int:
        raise NotImplementedError()

    @property
    @abstractmethod
    def tileDefaultHeight(self) -> int:
        raise NotImplementedError()

    @abstractmethod
    def getCharacterAdvance(self, character: str) -> int:
        raise NotImplementedError()

    @abstractmethod
    def render(self, character: str) -> pygame.Surface:
        raise NotImplementedError()
