class CharacterTile:
    __slots__ = ['x1', 'y1', 'x2', 'y2', 'advance']

    def __init__(self, x1: int = 0, y1: int = 0, x2: int = 0, y2: int = 0, advance: int = None):
        self.x1 = x1
        self.y1 = y1
        self.x2 = x2
        self.y2 = y2
        if advance is None:
            self.advance = x2 - x1
        else:
            self.advance = advance

    @property
    def width(self) -> int:
        return self.x2 - self.x1

    @property
    def height(self) -> int:
        return self.y2 - self.y1

    def __str__(self):
        return "{},{},{},{},{}".format(self.x1, self.y1, self.x2, self.y2, self.advance)
