from abc import abstractmethod

import numpy as np

from . import Layer


class GridLayer(Layer):

    @abstractmethod
    def setTiles(self, grid: np.ndarray):
        raise NotImplementedError()

    @abstractmethod
    def setTile(self, x: int, y: int, tileX: int, tileY: int, width: int = 1, height: int = 1):
        raise NotImplementedError()

    @abstractmethod
    def getPixelCell(self, x: int, y: int) -> (int, int):
        """
        x, y: pixel word coordinates (does not depend on view)
        """
        raise NotImplementedError()
