from abc import abstractmethod, ABC


class Layer(ABC):

    @abstractmethod
    def setTileset(self, fileName: str):
        raise NotImplementedError()

    @property
    @abstractmethod
    def tileWidth(self) -> int:
        raise NotImplementedError()

    @property
    @abstractmethod
    def tileHeight(self) -> int:
        raise NotImplementedError()

    @abstractmethod
    def setTileSize(self, tileWidth: int, tileHeight: int):
        raise NotImplementedError()

    @abstractmethod
    def setTilesetShift(self, x: float, y: float):
        raise NotImplementedError()
    
    @abstractmethod
    def draw(self):
        raise NotImplementedError()

    @abstractmethod
    def deleteObjects(self):
        raise NotImplementedError()

