from __future__ import annotations
from abc import ABC, abstractmethod

from state.Region import REGION_MAX_WIDTH, REGION_MAX_HEIGHT

REGION_PRIORITY = 100

CHARACTER_PRIORITY = 200 + REGION_MAX_WIDTH * REGION_MAX_HEIGHT
CHARACTER_DIRECTION_PRIORITY = CHARACTER_PRIORITY + 1
CHARACTER_MOVE_PRIORITY = CHARACTER_PRIORITY + 2

STATE_PRIORITY = CHARACTER_PRIORITY + 100


class Command(ABC):

    @abstractmethod
    def priority(self) -> int:
        raise NotImplementedError()

    @abstractmethod
    def execute(self, logic: Logic):
        raise NotImplementedError()
