from __future__ import annotations

from state import State, Character
from logic.command.Command import Command, STATE_PRIORITY
from logic import Logic


class CreateRegionCommand(Command):

    def __init__(self, state: State, name: str, width: int, height: int):
        self.__state = state
        self.__name = name
        self.__width = width
        self.__height = height

    def priority(self) -> int:
        return STATE_PRIORITY

    def execute(self, logic: Logic):
        self.__state.createRegion(self.__name, self.__width, self.__height)
        self.__state.notifyCurrentRegionChanged(self.__name)

