from __future__ import annotations

from logic import Logic
from logic.command.Command import Command, STATE_PRIORITY
from state import StateListener
from state.io import MainIO


class LoadStateCommand(Command):

    def __init__(self, stateListener: StateListener, fileName: str):
        self.__stateListener = stateListener
        self.__fileName = fileName

    def priority(self) -> int:
        return STATE_PRIORITY

    def execute(self, logic: Logic):
        state = MainIO.load(self.__fileName)
        self.__stateListener.stateChanged(state)

