from typing import Union

from gui import GUIFacade
from state import Region, Character


class Renderer:

    def __init__(self, gui: GUIFacade):
        self._gui = gui

    def updateAll(self, region: Union[None, Region]):
        pass

    def updateTile(self, region: Region, x: int, y: int):
        pass

    def updateCharacter(self, index: int, character: Character):
        pass

    def updateAnimations(self, time: float, epochFrame: float):
        pass

    code2tile = {
        # Code 0
        # 000
        # 000
        # 000
        0: [0, 0],

        # Code 2
        # 000
        # 100
        # 000
        2: [3, 0],

        # Code 8
        # 010
        # 000
        # 000
        8: [4, 2],

        # Code 10
        # 010
        # 100
        # 000
        10: [1, 2],

        # Code 11
        # 110
        # 100
        # 000
        11: [7, 2],

        # Code 16
        # 000
        # 000
        # 010
        16: [4, 0],

        # Code 18
        # 000
        # 100
        # 010
        18: [1, 1],

        # Code 22
        # 000
        # 100
        # 110
        22: [7, 0],

        # Code 24
        # 010
        # 000
        # 010
        24: [4, 1],

        # Code 26
        # 010
        # 100
        # 010
        26: [3, 2],

        # Code 27
        # 110
        # 100
        # 010
        27: [1, 3],

        # Code 30
        # 010
        # 100
        # 110
        30: [1, 4],

        # Code 31
        # 110
        # 100
        # 110
        31: [7, 1],

        # Code 64
        # 000
        # 001
        # 000
        64: [1, 0],

        # Code 66
        # 000
        # 101
        # 000
        66: [2, 0],

        # Code 72
        # 010
        # 001
        # 000
        72: [0, 2],

        # Code 74
        # 010
        # 101
        # 000
        74: [2, 2],

        # Code 75
        # 110
        # 101
        # 000
        75: [2, 4],

        # Code 80
        # 000
        # 001
        # 010
        80: [0, 1],

        # Code 82
        # 000
        # 101
        # 010
        82: [3, 1],

        # Code 86
        # 000
        # 101
        # 110
        86: [2, 3],

        # Code 88
        # 010
        # 001
        # 010
        88: [2, 1],

        # Code 90
        # 010
        # 101
        # 010
        90: [6, 5],

        # Code 91
        # 110
        # 101
        # 010
        91: [6, 3],

        # Code 94
        # 010
        # 101
        # 110
        94: [6, 4],

        # Code 95
        # 110
        # 101
        # 110
        95: [2, 5],

        # Code 104
        # 011
        # 001
        # 000
        104: [5, 2],

        # Code 106
        # 011
        # 101
        # 000
        106: [3, 4],

        # Code 107
        # 111
        # 101
        # 000
        107: [6, 2],

        # Code 120
        # 011
        # 001
        # 010
        120: [0, 3],

        # Code 122
        # 011
        # 101
        # 010
        122: [7, 3],

        # Code 123
        # 111
        # 101
        # 010
        123: [1, 5],

        # Code 126
        # 011
        # 101
        # 110
        126: [5, 5],

        # Code 127
        # 111
        # 101
        # 110
        127: [4, 3],

        # Code 208
        # 000
        # 001
        # 011
        208: [5, 0],

        # Code 210
        # 000
        # 101
        # 011
        210: [3, 3],

        # Code 214
        # 000
        # 101
        # 111
        214: [6, 0],

        # Code 216
        # 010
        # 001
        # 011
        216: [0, 4],

        # Code 218
        # 010
        # 101
        # 011
        218: [7, 4],

        # Code 219
        # 110
        # 101
        # 011
        219: [4, 5],

        # Code 222
        # 010
        # 101
        # 111
        222: [0, 5],

        # Code 223
        # 110
        # 101
        # 111
        223: [4, 4],

        # Code 248
        # 011
        # 001
        # 011
        248: [5, 1],

        # Code 250
        # 011
        # 101
        # 011
        250: [3, 5],

        # Code 251
        # 111
        # 101
        # 011
        251: [5, 3],

        # Code 254
        # 011
        # 101
        # 111
        254: [5, 4],

        # Code 255
        # 111
        # 101
        # 111
        255: [6, 1],
    }