from __future__ import annotations
from abc import ABC, abstractmethod


class StateListener(ABC):

    def stateChanged(self, state: State):
        return

    def currentRegionChanged(self, state: State, regionName: str):
        return

    def regionCellChanged(self, state: State, regionName: str, x: int, y: int):
        return

    def characterChanged(self, state: State, regionName: str, characterIndex: int):
        return
